Index: src/edu/ucsb/nceas/metacat/admin/PropertiesAdmin.java
===================================================================
--- src/edu/ucsb/nceas/metacat/admin/PropertiesAdmin.java	(nonexistent)
+++ src/edu/ucsb/nceas/metacat/admin/PropertiesAdmin.java	(revision 4080)
@@ -0,0 +1,276 @@
+/**
+ *  '$RCSfile$'
+ *    Purpose:  A Class that implements main property configuration methods
+ *  Copyright: 2008 Regents of the University of California and the
+ *             National Center for Ecological Analysis and Synthesis
+ *    Authors: Michael Daigle
+ *
+ *   '$Author$'
+ *     '$Date$'
+ * '$Revision$'
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ */
+
+package edu.ucsb.nceas.metacat.admin;
+
+import java.io.IOException;
+import java.util.Vector;
+
+import javax.servlet.ServletException;
+import javax.servlet.http.HttpServletRequest;
+import javax.servlet.http.HttpServletResponse;
+
+import org.apache.log4j.Logger;
+
+import edu.ucsb.nceas.metacat.DBVersion;
+import edu.ucsb.nceas.metacat.MetaCatVersion;
+import edu.ucsb.nceas.metacat.service.PropertyService;
+import edu.ucsb.nceas.metacat.util.RequestUtil;
+import edu.ucsb.nceas.metacat.util.SystemUtil;
+
+import edu.ucsb.nceas.utilities.FileUtil;
+import edu.ucsb.nceas.utilities.GeneralPropertyException;
+import edu.ucsb.nceas.utilities.PropertiesMetaData;
+import edu.ucsb.nceas.utilities.PropertyNotFoundException;
+import edu.ucsb.nceas.utilities.SortedProperties;
+
+/**
+ * Control the display of the main properties configuration page and the 
+ * processing of the configuration values.
+ */
+public class PropertiesAdmin extends MetaCatAdmin {
+
+	private static PropertiesAdmin propertiesAdmin = null;
+	private static Logger logMetacat = Logger.getLogger(PropertiesAdmin.class);
+
+	/**
+	 * private constructor since this is a singleton
+	 */
+	private PropertiesAdmin() {}
+
+	/**
+	 * Get the single instance of the MetaCatConfig.
+	 * 
+	 * @return the single instance of MetaCatConfig
+	 */
+	public static PropertiesAdmin getInstance() {
+		if (propertiesAdmin == null) {
+			propertiesAdmin = new PropertiesAdmin();
+		}
+		return propertiesAdmin;
+	}
+	
+	/**
+	 * Handle configuration of the main application properties
+	 * 
+	 * @param request
+	 *            the http request object
+	 * @param response
+	 *            the http response to be sent back to the client
+	 */
+	public void configureProperties(HttpServletRequest request,
+			HttpServletResponse response) throws AdminException {
+
+		String processForm = request.getParameter("processForm");
+		String formErrors = (String)request.getAttribute("formErrors");
+
+		if (processForm == null || !processForm.equals("true") || formErrors != null) {
+			// The servlet configuration parameters have not been set, or there
+			// were form errors on the last attempt to configure, so redirect to
+			// the web form for configuring metacat
+
+			try {
+				// Load the properties metadata file so that the JSP page can
+				// use the metadata to construct the editing form
+				PropertiesMetaData metadata = PropertyService.getMainMetaData();
+				request.setAttribute("metadata", metadata);
+
+				// Attempt to discover the following properties.  These will show
+				// up in the configuration fields if nothing else is provided.
+				PropertyService.setPropertyNoPersist("application.context",
+						SystemUtil.discoverApplicationContext(request));
+				PropertyService.setPropertyNoPersist("server.name", SystemUtil
+						.discoverServerName(request));
+				PropertyService.setPropertyNoPersist("server.httpPort", SystemUtil
+						.discoverServerPort(request));
+				PropertyService.setPropertyNoPersist("server.httpSSLPort",
+						SystemUtil.discoverServerSSLPort(request));
+				PropertyService.setPropertyNoPersist("application.tomcatDir",
+						SystemUtil.discoverTomcatDir(request));
+
+				PropertyService.persistProperties();
+
+				// Add the list of properties from metacat.properties to the request
+				Vector<String> propertyNames = PropertyService.getPropertyNames();
+				for (String propertyName : propertyNames) {
+					request.setAttribute(propertyName, PropertyService.getProperty(propertyName));
+				}
+
+				// Check for any backup properties and apply them to the
+				// request. These are properties from previous configurations. 
+				// They keep the user from having to re-enter all values when 
+				// upgrading. If this is a first time install, getBackupProperties 
+				// will return null.
+				SortedProperties backupProperties = null;
+				if ((backupProperties = 
+						PropertyService.getMainBackupProperties()) != null) {
+					Vector<String> backupKeys = backupProperties.getPropertyNames();
+					for (String key : backupKeys) {
+						String value = backupProperties.getProperty(key);
+						if (value != null) {
+							request.setAttribute(key, value);
+						}
+					}
+				}
+
+				// Forward the request to the JSP page
+				RequestUtil.forwardRequest(request, response,
+						"/admin/properties-configuration.jsp");
+
+			} catch (PropertyNotFoundException pnfe) {
+				throw new AdminException("Problem getting property while initializing "
+								+ "system properties page: " + pnfe.getMessage());
+			} catch (IOException ioe) {
+				throw new AdminException("IO problem while initializing "
+						+ "system properties page:" + ioe.getMessage());
+			} catch (ServletException se) {
+				throw new AdminException("problem forwarding request while " 
+						+ "initializing system properties page: " + se.getMessage());
+			}
+		} else {
+			// The configuration form is being submitted and needs to be
+			// processed.
+			Vector<String> validationErrors = new Vector<String>();
+			Vector<String> processingErrors = new Vector<String>();
+			Vector<String> processingSuccess = new Vector<String>();
+
+			MetaCatVersion metacatVersion = null;
+			
+			try {
+				metacatVersion = SystemUtil.getMetacatVersion();
+				
+				// For each property, check if it is changed and save it
+				Vector<String> propertyNames = PropertyService.getPropertyNames();
+				for (String name : propertyNames) {
+					PropertyService.checkAndSetProperty(request, name);
+				}
+
+				// we need to write the options from memory to the properties
+				// file
+				PropertyService.persistProperties();
+
+				// Validate that the options provided are legitimate. Note that
+				// we've allowed them to persist their entries. As of this point
+				// there is no other easy way to go back to the configure form
+				// and preserve their entries.
+				validationErrors.addAll(validateOptions(request));
+
+				// Try to create backup directories if necessary.
+				String backupDir = PropertyService.getBackupDir();
+				if (!FileUtil.createDirectory(backupDir)) {
+					String errorString = "Could not create directory: " + backupDir;
+					logMetacat.error(errorString);
+					validationErrors.add(errorString);
+				}
+
+				// write the backup properties to a location outside the 
+				// application directories so they will be available after
+				// the next upgrade
+				PropertyService.persistMainBackupProperties(
+						request.getSession().getServletContext());
+
+			} catch (GeneralPropertyException gpe) {
+				String errorMessage = "Problem getting or setting property while "
+						+ "processing system properties page: " + gpe.getMessage();
+				logMetacat.error(errorMessage);
+				processingErrors.add(errorMessage);
+			} catch (IOException ioe) {
+				String errorMessage = "IO problem while processing system "
+						+ "properties page: " + ioe.getMessage();
+				logMetacat.error(errorMessage);
+				processingErrors.add(errorMessage);
+			}
+			
+			try {
+				if (validationErrors.size() > 0 || processingErrors.size() > 0) {
+					RequestUtil.clearRequestMessages(request);
+					RequestUtil.setRequestFormErrors(request, validationErrors);
+					RequestUtil.setRequestErrors(request, processingErrors);
+					RequestUtil.forwardRequest(request, response, "/admin");
+				} else {
+					// Now that the options have been set, change the
+					// 'propertiesConfigured' option to 'true'
+					PropertyService.setProperty("configutil.propertiesConfigured",
+							PropertyService.CONFIGURED);
+					
+					// if the db version is already the same as the metacat version,
+					// update metacat.properties. Have to do this after
+					// propertiesConfigured is set to CONFIGURED
+					DBVersion dbVersion = DBAdmin.getInstance().getDBVersion();
+					if (dbVersion != null && metacatVersion != null && 
+							dbVersion.compareTo(metacatVersion) == 0) {
+						PropertyService.setProperty("databaseConfigured", 
+								PropertyService.CONFIGURED);
+					}
+					
+					// Reload the main metacat configuration page
+					processingSuccess.add("Properties successfully configured");
+					RequestUtil.clearRequestMessages(request);
+					RequestUtil.setRequestSuccess(request, processingSuccess);
+					RequestUtil.forwardRequest(request, response, 
+							"/admin?configureType=configure&processForm=false");
+				}
+
+			} catch (ServletException se) {
+				throw new AdminException("problem forwarding request while "
+						+ "processing system properties page: " + se.getMessage());
+			} catch (IOException ioe) {
+				throw new AdminException("IO problem while processing system "
+						+ "properties page: " + ioe.getMessage());
+			}
+		}
+	}
+
+	/**
+	 * Validate the most important configuration options submitted by the user.
+	 * 
+	 * @param request
+	 *            the http request object
+	 * 
+	 * @return a vector holding error message for any fields that fail
+	 *         validation.
+	 */
+	protected Vector<String> validateOptions(HttpServletRequest request) {
+		Vector<String> errorVector = new Vector<String>();
+
+		// Test database connectivity
+		try {
+			String dbError = DBAdmin.getInstance().validateDBConnectivity(
+					request.getParameter("database.driver"),
+					request.getParameter("database.connectionURI"),
+					request.getParameter("database.user"),
+					request.getParameter("database.password"));
+			if (dbError != null) {
+				errorVector.add(dbError);
+			}
+		} catch (AdminException ae) {
+			errorVector.add("Could not instantiate database admin: "
+					+ ae.getMessage());
+		}
+
+		return errorVector;
+	}
+}
\ No newline at end of file

Index: src/edu/ucsb/nceas/metacat/admin/AuthAdmin.java
===================================================================
--- src/edu/ucsb/nceas/metacat/admin/AuthAdmin.java	(nonexistent)
+++ src/edu/ucsb/nceas/metacat/admin/AuthAdmin.java	(revision 4080)
@@ -0,0 +1,184 @@
+/**
+ *  '$RCSfile$'
+ *    Purpose: A Class that implements ldap configuration methods
+ *  Copyright: 2008 Regents of the University of California and the
+ *             National Center for Ecological Analysis and Synthesis
+ *    Authors: Michael Daigle
+ *
+ *   '$Author$'
+ *     '$Date$'
+ * '$Revision$'
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ */
+
+package edu.ucsb.nceas.metacat.admin;
+
+import java.io.IOException;
+import java.util.Set;
+import java.util.SortedMap;
+import java.util.Vector;
+
+import javax.servlet.ServletException;
+import javax.servlet.http.HttpServletRequest;
+import javax.servlet.http.HttpServletResponse;
+
+import org.apache.log4j.Logger;
+
+import edu.ucsb.nceas.metacat.service.PropertyService;
+import edu.ucsb.nceas.metacat.util.LDAPUtil;
+import edu.ucsb.nceas.metacat.util.RequestUtil;
+import edu.ucsb.nceas.metacat.util.UtilException;
+import edu.ucsb.nceas.utilities.FileUtil;
+import edu.ucsb.nceas.utilities.GeneralPropertyException;
+import edu.ucsb.nceas.utilities.MetaDataProperty;
+import edu.ucsb.nceas.utilities.PropertiesMetaData;
+import edu.ucsb.nceas.utilities.PropertyNotFoundException;
+import edu.ucsb.nceas.utilities.SortedProperties;
+
+/**
+ * Control the display of the LDAP configuration page and the processing
+ * of the configuration values.
+ */
+public class AuthAdmin extends MetaCatAdmin {
+
+	private static AuthAdmin authAdmin = null;
+	private static Logger logMetacat = Logger.getLogger(AuthAdmin.class);
+
+	/**
+	 * private constructor since this is a singleton
+	 */
+	private AuthAdmin() {}
+
+	/**
+	 * Get the single instance of AuthAdmin.
+	 * 
+	 * @return the single instance of AuthAdmin
+	 */
+	public static AuthAdmin getInstance() {
+		if (authAdmin == null) {
+			authAdmin = new AuthAdmin();
+		}
+		return authAdmin;
+	}
+	
+	/**
+	 * Handle configuration of the LDAP properties
+	 * 
+	 * @param request
+	 *            the http request information
+	 * @param response
+	 *            the http response to be sent back to the client
+	 */
+	public void authenticateUser(HttpServletRequest request,
+			HttpServletResponse response) throws AdminException {
+
+		String processForm = request.getParameter("processForm");
+		String formErrors = (String) request.getAttribute("formErrors");
+
+		if (processForm == null || !processForm.equals("true") || formErrors != null) {
+			// The servlet configuration parameters have not been set, or there
+			// were form errors on the last attempt to configure, so redirect to
+			// the web form for configuring metacat
+			
+			try {
+				// Forward the request to the JSP page
+				RequestUtil.forwardRequest(request, response,
+						"/admin/admin-login.jsp");
+			} catch (IOException ioe) {
+				throw new AdminException("IO problem while initializing "
+						+ "user login page:" + ioe.getMessage());
+			} catch (ServletException se) {
+				throw new AdminException("problem forwarding request while "
+						+ "initializing user login page: " + se.getMessage());
+			}
+		} else {
+			// The configuration form is being submitted and needs to be
+			// processed.
+			Vector<String> processingSuccess = new Vector<String>();
+			Vector<String> processingErrors = new Vector<String>();
+			Vector<String> validationErrors = new Vector<String>();
+			
+			String loginString = null;
+			Boolean isLoggedIn = false;
+
+			try {
+				String userName = request.getParameter("username");
+				String organization = request.getParameter("organization");
+				String password = request.getParameter("password");
+				
+				// Validate that the options provided are legitimate. Note that
+				// we've allowed them to persist their entries. As of this point
+				// there is no other easy way to go back to the configure form
+				// and preserve their entries.
+				validationErrors.addAll(validateOptions(request));
+				
+				if (validationErrors.size() == 0) {
+					Vector<String> dnList = LDAPUtil.getOrgDNs(organization);
+					isLoggedIn = LDAPUtil.logUserIn(request, userName, organization, dnList, password);
+					loginString = LDAPUtil.createLDAPString(userName, organization, dnList);
+				}
+				
+				if (!isLoggedIn) {
+					String errorMessage = "Could not log in as: " + loginString
+							+ " .Please try again";
+					processingErrors.add(errorMessage);
+				}
+			} catch (UtilException ue) {
+				String errorMessage = "Problem in utility while "
+					+ "processing authentication page: " + ue.getMessage();
+				processingErrors.add(errorMessage);
+				logMetacat.error(errorMessage);
+			} 
+			
+			try {
+				if (validationErrors.size() > 0 || processingErrors.size() > 0) {
+					RequestUtil.clearRequestMessages(request);
+					RequestUtil.setRequestFormErrors(request, validationErrors);
+					RequestUtil.setRequestErrors(request, processingErrors);
+					RequestUtil.forwardRequest(request, response, "/admin");
+				} else {
+					// Reload the main metacat configuration page
+					processingSuccess.add("User logged in as: " + loginString);
+					RequestUtil.clearRequestMessages(request);
+					RequestUtil.setUserId(request, loginString);
+					RequestUtil.setRequestSuccess(request, processingSuccess);
+					RequestUtil.forwardRequest(request, response,
+							"/admin?configureType=configure&processForm=false");
+				}
+			} catch (IOException ioe) {
+				throw new AdminException("IO problem while processing LDAP "
+						+ "properties page: " + ioe.getMessage());
+			} catch (ServletException se) {
+				throw new AdminException("problem forwarding request while "
+						+ "processoing LDAP properties page: " + se.getMessage());
+			}
+		}
+	}
+	
+	/**
+	 * Validate the most important configuration options submitted by the user.
+	 * 
+	 * @return a vector holding error message for any fields that fail
+	 *         validation.
+	 */
+	protected Vector<String> validateOptions(HttpServletRequest request) {
+		Vector<String> errorVector = new Vector<String>();
+
+		//TODO MCD validate options.
+
+		return errorVector;
+	}
+}
\ No newline at end of file

Index: src/edu/ucsb/nceas/metacat/Eml210SAXHandler.java
===================================================================
--- src/edu/ucsb/nceas/metacat/Eml210SAXHandler.java	(revision 4079)
+++ src/edu/ucsb/nceas/metacat/Eml210SAXHandler.java	(revision 4080)
@@ -47,6 +47,10 @@
 import org.xml.sax.Attributes;
 import org.xml.sax.SAXException;
 
+import edu.ucsb.nceas.metacat.service.PropertyService;
+import edu.ucsb.nceas.metacat.util.MetaCatUtil;
+import edu.ucsb.nceas.utilities.PropertyNotFoundException;
+
 /**
  * A database aware Class implementing callback bethods for the SAX parser to
  * call when processing the XML stream and generating events
@@ -192,7 +196,7 @@
         // Get the unchangable subtrees (user doesn't have write permission)
         try {
             PermissionController control = new PermissionController(docid
-                    + MetaCatUtil.getOption("accNumSeparator") + revision);
+                    + PropertyService.getProperty("accNumSeparator") + revision);
             //unChangableSubTreeHash = getUnchangableSubTree(control, user,
             // groups);
 
@@ -341,7 +345,13 @@
                 inlineDataNameSpace = new Hashtable();
                 //initialize file writer
                 String docidWithoutRev = MetaCatUtil.getDocIdFromString(docid);
-                String seperator = MetaCatUtil.getOption("accNumSeparator");
+                String seperator = ".";
+                try {
+                seperator = PropertyService.getProperty("accNumSeparator");
+                } catch (PropertyNotFoundException pnfe) {
+                	logMetacat.error("Could not fing property 'accNumSeparator'. " 
+                			+ "Setting separator to '.': " + pnfe.getMessage());
+                }
                 // the new file name will look like docid.rev.2
                 inlineDataFileName = docidWithoutRev + seperator + revision
                         + seperator + inLineDataIndex;
@@ -1012,9 +1022,9 @@
                         handleOnlineUrlDataFile(data);
                         /*if (data != null
                                 && (data.indexOf(MetaCatUtil
-                                        .getOption("httpserver")) != -1 || data
+                                        .getProperty("httpserver")) != -1 || data
                                         .indexOf(MetaCatUtil
-                                                .getOption("server")) != -1)) {
+                                                .getProperty("server")) != -1)) {
                             // Get docid from url
                             String dataId = MetaCatUtil
                                     .getDocIdWithRevFromOnlineURL(data);
@@ -1953,7 +1963,12 @@
             throws SAXException
     {
         FileWriter writer = null;
-        String path = MetaCatUtil.getOption("inlinedatafilepath");
+        String path;
+        try {
+        	path = PropertyService.getProperty("application.inlinedatafilepath");
+        } catch (PropertyNotFoundException pnfe) {
+        	throw new SAXException(pnfe.getMessage());
+        }
         /*
          * File inlineDataDirectory = new File(path);
          */
@@ -1991,12 +2006,13 @@
         // this method need to be testing
         boolean same = true;
         String data = null;
-        String path = MetaCatUtil.getOption("inlinedatafilepath");
-        // the new file name will look like path/docid.rev.2
-        File inlineDataDirectory = new File(path);
-        File oldDataFile = new File(inlineDataDirectory, oldFileName);
-        File newDataFile = new File(inlineDataDirectory, newFileName);
         try {
+        	String path = PropertyService.getProperty("application.inlinedatafilepath");
+			// the new file name will look like path/docid.rev.2
+			File inlineDataDirectory = new File(path);
+			File oldDataFile = new File(inlineDataDirectory, oldFileName);
+			File newDataFile = new File(inlineDataDirectory, newFileName);
+
             FileReader oldFileReader = new FileReader(oldDataFile);
             BufferedReader oldStringReader = new BufferedReader(oldFileReader);
             FileReader newFileReader = new FileReader(newDataFile);
@@ -2031,7 +2047,7 @@
 
     // if xml file failed to upload, we need to call this method to delete
     // the inline data already in file system
-    public void deleteInlineFiles()
+    public void deleteInlineFiles() throws SAXException
     {
         if (!inlineFileIDList.isEmpty()) {
             for (int i = 0; i < inlineFileIDList.size(); i++) {
@@ -2042,10 +2058,15 @@
     }
 
     /* delete the inline data file */
-    private void deleteInlineDataFile(String fileName)
+    private void deleteInlineDataFile(String fileName) throws SAXException
     {
-
-        String path = MetaCatUtil.getOption("inlinedatafilepath");
+    	String path;
+    	try {
+        	path = PropertyService.getProperty("application.inlinedatafilepath");
+    	} catch (PropertyNotFoundException pnfe) {
+    		throw new SAXException ("Could not find inline data file path: " 
+    				+ pnfe.getMessage());
+    	}
         File inlineDataDirectory = new File(path);
         File newFile = new File(inlineDataDirectory, fileName);
         newFile.delete();
@@ -2053,28 +2074,28 @@
     }
 
     /*
-     * In eml2, the inline data wouldn't store in db, it store in file system
-     * The db stores file name(without path).
-     */
-    public static Reader readInlineDataFromFileSystem(String fileName)
-            throws McdbException
-    {
-        //BufferedReader stringReader = null;
-        FileReader fileReader = null;
-        String path = MetaCatUtil.getOption("inlinedatafilepath");
-        // the new file name will look like path/docid.rev.2
-        File inlineDataDirectory = new File(path);
-        File dataFile = new File(inlineDataDirectory, fileName);
-        try {
-            fileReader = new FileReader(dataFile);
-            //stringReader = new BufferedReader(fileReader);
-        } catch (Exception e) {
-            throw new McdbException(e.getMessage());
-        }
-        // return stringReader;
-        return fileReader;
-    }
+	 * In eml2, the inline data wouldn't store in db, it store in file system
+	 * The db stores file name(without path).
+	 */
+	public static Reader readInlineDataFromFileSystem(String fileName)
+			throws McdbException {
+		// BufferedReader stringReader = null;
+		FileReader fileReader = null;
+		try {
+			String path = PropertyService.getProperty("application.inlinedatafilepath");
+			// the new file name will look like path/docid.rev.2
+			File inlineDataDirectory = new File(path);
+			File dataFile = new File(inlineDataDirectory, fileName);
 
+			fileReader = new FileReader(dataFile);
+			// stringReader = new BufferedReader(fileReader);
+		} catch (Exception e) {
+			throw new McdbException(e.getMessage());
+		}
+		// return stringReader;
+		return fileReader;
+	}
+
     /* Delete relations */
     private void deleteRelations() throws SAXException
     {
Index: src/edu/ucsb/nceas/metacat/DBSimpleQuery.java
===================================================================
--- src/edu/ucsb/nceas/metacat/DBSimpleQuery.java	(revision 4079)
+++ src/edu/ucsb/nceas/metacat/DBSimpleQuery.java	(revision 4080)
@@ -67,7 +67,6 @@
           String doctype  = args[1];
 
           // Open a connection to the database
-          MetaCatUtil   util = new MetaCatUtil();
           //Connection dbconn = util.openDBConnection();
 
           // Execute the simple query
Index: src/xmltables-sqlserver.sql
===================================================================
--- src/xmltables-sqlserver.sql	(revision 4079)
+++ src/xmltables-sqlserver.sql	(revision 4080)
@@ -30,6 +30,7 @@
 drop table [dbo].[harvest_site_schedule];
 drop table [dbo].[harvest_log];
 drop table [dbo].[harvest_detail_log];
+drop table [dbo].[db_version];
 
 /* 
  * ACL -- table to store ACL for XML documents by principals
@@ -237,6 +238,17 @@
 GO
 
 /* 
+ * db_version -- table to store the version history of this database
+ */
+CREATE TABLE [dbo].[db_version] (
+  [db_version_id]	[bigint] IDENTITY (1, 1) NOT NULL ,
+  [version]		    [varchar] (250) NOT NULL ,
+  [status]		    [int] NOT NULL ,
+  [date_created]	[datetime] NULL
+) ON [PRIMARY]
+GO
+
+/* 
  * Constraints and indexes
  */
 ALTER TABLE [dbo].[xml_catalog] WITH NOCHECK ADD 
@@ -310,6 +322,13 @@
 	)  ON [PRIMARY] 
 GO
 
+ALTER TABLE [dbo].[db_version] WITH NOCHECK ADD 
+	CONSTRAINT [PK_db_version] PRIMARY KEY  CLUSTERED 
+	(
+		[db_version_id]
+	)  ON [PRIMARY] 
+GO
+
 ALTER TABLE [dbo].[xml_access] WITH NOCHECK ADD 
 	CONSTRAINT [CK_xml_access] CHECK ([begin_time] < [end_time])
 GO
